#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire700three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 700"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire700three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three7004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three7004xi = {
                1:'0x13y-699z',
                2:'0x165y-680z',
                3:'0x20y-699z',
                4:'0x679y-168z',
                5:'0x6y-699z',
                6:'100x85y-687z',
                7:'101x201y-662z',
                8:'103x586y-368z',
                9:'107x675y-147z',
                10:'110x84y-686z',
                11:'114x201y-660z',
                12:'11x14y-699z',
                13:'11x47y-698z',
                14:'120x82y-684z',
                15:'121x627y-286z',
                16:'128x200y-658z',
                17:'129x613y-496z',
                18:'134x583y-362z',
                19:'142x534y-428z',
                20:'142x670y-140z',
                21:'143x199y-655z',
                22:'155x622y-279z',
                23:'157x196y-653z',
                24:'15x53y-697z',
                25:'165x579y-356z',
                26:'171x192y-650z',
                27:'171x530y-423z',
                28:'177x663y-134z',
                29:'17x177y-676z',
                30:'17x18y-699z',
                31:'186x188y-647z',
                32:'188x616y-273z',
                33:'196x572y-350z',
                34:'200x182y-645z',
                35:'200x524y-417z',
                36:'212x654y-127z',
                37:'214x176y-642z',
                38:'21x59y-697z',
                39:'21x629y-305z',
                40:'221x608y-266z',
                41:'227x565y-344z',
                42:'228x168y-639z',
                43:'229x517y-412z',
                44:'22x22y-699z',
                45:'242x159y-636z',
                46:'247x643y-120z',
                47:'253x598y-260z',
                48:'257x508y-406z',
                49:'258x555y-338z',
                50:'26x64y-696z',
                51:'27x183y-675z',
                52:'280x631y-113z',
                53:'285x586y-253z',
                54:'286x497y-400z',
                55:'288x544y-332z',
                56:'29x25y-698z',
                57:'2x27y-699z',
                58:'2x3y-699z',
                59:'313x485y-395z',
                60:'314x616y-106z',
                61:'317x572y-247z',
                62:'318x531y-326z',
                63:'33x69y-695z',
                64:'341x471y-389z',
                65:'346x600y-99z',
                66:'347x516y-320z',
                67:'348x557y-240z',
                68:'35x680y-161z',
                69:'367x455y-383z',
                70:'36x28y-698z',
                71:'376x499y-313z',
                72:'377x581y-92z',
                73:'378x540y-234z',
                74:'38x188y-673z',
                75:'393x438y-377z',
                76:'403x481y-307z',
                77:'407x521y-227z',
                78:'408x562y-85z',
                79:'40x586y-380z',
                80:'40x73y-694z',
                81:'418x420y-371z',
                82:'430x462y-301z',
                83:'435x501y-220z',
                84:'437x540y-78z',
                85:'43x30y-697z',
                86:'442x400y-365z',
                87:'456x441y-294z',
                88:'462x479y-214z',
                89:'465x517y-71z',
                90:'466x378y-359z',
                91:'47x77y-694z',
                92:'481x418y-288z',
                93:'488x355y-353z',
                94:'488x455y-207z',
                95:'492x492y-64z',
                96:'4x34y-699z',
                97:'504x394y-282z',
                98:'50x192y-671z',
                99:'513x431y-200z',
                100:'518x466y-57z',
                101:'526x369y-275z',
                102:'537x404y-194z',
                103:'542x439y-50z',
                104:'559x377y-187z',
                105:'55x630y-298z',
                106:'55x80y-693z',
                107:'565x410y-43z',
                108:'62x195y-669z',
                109:'63x82y-692z',
                110:'6x8y-699z',
                111:'71x586y-374z',
                112:'71x678y-154z',
                113:'72x84y-691z',
                114:'74x198y-667z',
                115:'7x41y-698z',
                116:'81x85y-689z',
                117:'87x200y-664z',
                118:'88x629y-292z',
                119:'8x171y-678z',
                120:'91x85y-688z',
                121:'9x583y-386z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire700three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire700three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE700THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE700THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE700THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE700THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE700THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three7004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE700THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE700THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE700THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three7004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three7004xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE700THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE700THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE700THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire700three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                